/* Generate coff file
   Copyright 2002, 2003, 2004, 2005
   Craig Franklin
*/

#pragma once

#define SECTION_FLAGS           state.obj.flags
#define IS_RAM_ORG              (SECTION_FLAGS & STYP_RAM_AREA)

extern void coff_init(void);
extern void coff_cleanup_before_eof(void);
extern void coff_close_file(void);
extern void coff_new_section(const char *Name, unsigned Byte_addr, unsigned Flags);
extern void coff_close_section(void);

extern gp_symbol_t *coff_add_sym(const char *Name, gpasmVal Value, enum gpasmValTypes Type,
                                 int Section_number);

extern void coff_add_reloc(unsigned Symbol_number, int16_t Offset, uint16_t Type);
extern void coff_add_linenum(unsigned Emitted);
extern gp_symbol_t *coff_add_file_sym(const char *File_name, bool Is_include);
extern void coff_add_eof_sym(void);
extern void coff_add_list_sym(void);
extern void coff_add_nolist_sym(void);
extern void coff_add_direct_sym(uint8_t Command, const char *String);
extern void coff_add_ident_sym(const char *String);
extern char *coff_local_name(const char *Name);

