/* Bit array support

   Copyright 2016 Molnár Károly
*/

#pragma once

#include "stdhdr.h"

typedef struct gp_bit_array {
  size_t    bit_length;                 /* Number of stored bits. */
  size_t    byte_length;                /* Real size of storage in bytes. */
  size_t    group_length;               /* Real size of storage in groups. */
  uint64_t *array;
} gp_bit_array_t;

extern void gp_bitarray_create(gp_bit_array_t *Bits, size_t Bit_size);
extern void gp_bitarray_delete(gp_bit_array_t *Bits);
extern bool gp_bitarray_write(gp_bit_array_t *Bits, size_t Bit_index, bool Value);

extern bool gp_bitarray_write_range(gp_bit_array_t *Bits, size_t Bit_index_start,
                                          size_t Bit_index_end, bool Value);

extern bool gp_bitarray_clear(gp_bit_array_t *Bits);

extern bool gp_bitarray_read(const gp_bit_array_t *Bits, size_t Bit_index);

extern bool gp_bitarray_get_range_borders(const gp_bit_array_t *Bits, size_t Bit_index,
                                                size_t *Start, size_t *End);
